#!/usr/bin/perl
# Created by Ben Okopnik on Fri May  6 00:12:17 EDT 2005
use warnings;
# use CGI::Carp qw(fatalsToBrowser warningsToBrowser);
use CGI qw/:standard :cgi-lib/;
use File::Find;
$|++;

my ($symlink, $link, @files);

###################### User-modifiable variables #######################
$symlink = "24x24";		# Name of symlinked local directory
###################### User-modifiable variables #######################

($link = readlink $symlink) =~ s#/$symlink##;

sub wanted {
	return if $File::Find::dir =~ /animations/;
	push @files, $File::Find::name if /\.png$/;
}
find { wanted => \&wanted, follow => 1, no_chdir => 1 }, qw#24x24#;
chomp @files;

# Make the source layout a little more readable
$, = "\n";

print header, start_html( 'IDesk icon configurator' ),
     h2( { -align => 'center' }, 'IDesk icon configurator' );

if ( ! param() ){
    print start_form,
     	 table( { -align => 'center' }, Tr(
		    td( { -width => '25%' }, b( "Caption? " ), br, textfield('caption') ),
		    td( { -width => '25%' }, b( "Left-click command? " ), br, textfield( 'left' ) ),
		    td( { -width => '25%' }, b( "Right-click command (optional)? " ), br, textfield( 'right' ) ) 
		)
	 ),
         h3( { -style => 'background-color: blue; color: white; text-align: center' },
			 'Click on an icon to create the IDesk link file' ),
         map ( { 
			 image_button( 
				 -name => $_,
				 -src  => $_,
				 -hspace => 3,
				 -vspace => 2 
			 )
	        } @files 
	 ),
     end_form;
}
elsif ( ! param( 'left' ) || ! param( 'caption' ) ){
	print b( 'The caption must be filled in.' ), br
		unless param( 'caption' );
	print b( 'The left-click command must be filled in.' ), p
		unless param( 'left' );
	print "Click ", a( { -href => url }, 'here' ), " to go back.";
}
else {
    # Get all the params in one hash
    my %h = Vars();

    # Filename is going to be based on the caption
    my $fname = $h{ caption };
    
    # Just in case something goes wrong...
    while ( ( ! $fname ) || -f "../$fname.lnk" ){
	    $fname = $fname . int rand 10;
    }
    # Sanitize the name - convert all '\W' chars to '_'
    $fname =~ y/a-zA-Z0-9/_/c;

    # If undefined, the right click command defaults to editing the linkfile.
    $h{ right } ||= "xterm -e /bin/vi ~/.idesktop/$fname.lnk";

    # Get the icon name (key) from the hash
    ( my $icon ) = grep m#^.*\.png\.x$#, keys %h;
    $icon =~ s/\.x$//;
    
    push my @out,
	"table Icon",
	"  Caption: $h{ caption }",
	"  X: 10",
	"  Y: 10",
	"  Icon: $link/$icon",
	"  Command[0]: $h{ left }",
	"  Command[1]: $h{ right }",
	"end";

    { 
	    local $" = "\n";
	    print img( { -src => $icon } ), br,
		    b( "Link file created as '~/.idesktop/$fname.lnk'" ), hr, pre( "@out" );

	    open  Fh, ">../$fname.lnk" or die "../$fname.lnk: $!\n";
	    print Fh "@out\n\n";
	    close Fh;
    }

    print hr, "Click ", a( { -href => "http://localhost:8080/builder/idesk.cgi" }, 'here' ), " to return to the Builder.";
}

print hr, end_html;

